// fileio.cpp

#ifndef _CONSOLE
#include "stdafx.h"
#endif

#include <stdio.h>
#include <string.h>
#include <math.h>
#include <malloc.h>

#include "skeleton.h"
#include "fileio.h"
#include "data.h"

char str[4096];

char CurrentDirectory[NFILE];
char CurrentFilename[NFILE];

BOOLEAN readbvh(char *fname)
{
	FILE *fp;
	char *token;
	int i, j, k, jointno, parent;
	BOOLEAN ok = FALSE;
	static double temp[3];

	if ( (fp = fopen(fname, "rt")) == NULL ){
		printf("file not found.\n");
		return ok;
	}

	for(;;){
		if ( fgets(str, sizeof(str), fp) == NULL) break;
		if ( *str == '\n' || *str == '#' ) continue;

		token = strchr( str, 'R' );
		if ( token && !strncmp(token, "ROOT", 4) ){
			jointno = 0;
			for(;;){
				if ( fgets(str, sizeof(str), fp) == NULL) break;
				token = strchr( str, 'O' );
				if ( token && !strncmp(token, "OFFSET", 6) ){
					sscanf( token + 7, "%lf %lf %lf", &offset[jointno].x, &offset[jointno].y, &offset[jointno].z);
					break;
				}
			}
			parent = 0;
		}
		token = strchr( str, 'J' );
		if ( token && !strncmp(token, "JOINT", 5) ){
			jointno++;
			for(;;){
				if ( fgets(str, sizeof(str), fp) == NULL) break;
				token = strchr( str, 'O');
				if ( token && !strncmp(token, "OFFSET", 6) ){
					sscanf( token + 7, "%lf %lf %lf", &offset[jointno].x, &offset[jointno].y, &offset[jointno].z);
					break;
				}
			}
			parent_child( parent, jointno );
			parent = jointno;
		}
		token = strchr( str, 'E' );
		if ( token && !strncmp(token, "End", 3) ){
			for(;;){
				if ( fgets(str, sizeof(str), fp) == NULL) break;
				token = strchr( str, '}');
				if ( token ){
					strcpy(str, "");
					break;
				}
			}
		}
		token = strchr( str, '}' );
		if ( token ) parent = skeleton[ parent ].parent;

		if ( !strncmp(str, "MOTION", 6) ){
			for(;;){
				if ( fgets(str, sizeof(str), fp) == NULL ) break;
				if ( *str == '\n' || *str == '#' ) continue;
				if ( !strncmp(str, "Frames:", 7) ){
					sscanf(str+8, "%ld", &NFrames);
					if ( fgets(str, sizeof(str), fp) == NULL) break;
					for(i=0;i<NFrames;i++){
						if ( fgets(str, sizeof(str), fp) == NULL) break;
						token = str;
						while(*token == ' ' || *token == 9) token++;
						for(k=0;k<3;k++){
							sscanf(token, "%lf", &temp[k]);
							while(*token != ' ' && *token != 9 ) token++;
							while(*token == ' ' || *token == 9 ) token++;
						}
						positions[i].x = temp[0];
						positions[i].y = temp[1];
						positions[i].z = temp[2];
//						positions[i].x = 0.0; positions[i].y = 0.0; positions[i].z = 0.0;

						for(j=0;j<BVHJoints;j++){
							for(k=0;k<3;k++){
								sscanf(token, "%lf", &temp[k]);
								while(*token != ' ' && *token != 9 ) token++;
								while(*token == ' ' || *token == 9 ) token++;
							}
							angles[i][j].x = temp[1] * PI / 180.0;
							angles[i][j].y = temp[2] * PI / 180.0;
							angles[i][j].z = temp[0] * PI / 180.0;
						}
					}
				}
			}
			ok = TRUE;
		}
	}
	fclose(fp);

// modified by okada
	frame_no = 0;
	return ok;
}

void writetest(char *fname)
{
	int i, j;
	Vector v;
	FILE *fp;

	if ( (fp = fopen( fname, "wt")) == NULL ) return;
	for(i = 0; i < BVHJoints; i++){
		sprintf(str, "Joint[%d] %lf %lf %lf\n", i, offset[i].x, offset[i].y, offset[i].z);
		fputs( str, fp );
	}
	for(i = 0; i < NFrames; i++){
/*
		sprintf(str, "%lf %lf %lf ", positions[i].x, positions[i].y, positions[i].z);
		fputs( str, fp );
		for(j = 0; j < BVHJoints; j++){
			sprintf(str, "%lf %lf %lf ", angles[i][j].x, angles[i][j].y, angles[i][j].z );
			fputs( str, fp );
		}
		fputs( "\n", fp );
*/
		update_skeleton( i );
		for(j = 0; j < BVHJoints; j++){
			v = *PositionMatrix( skeleton[j].BMat );
			sprintf(str, "%lf %lf %lf ", v.x, v.y, v.z);
			fputs( str, fp );
		}
		fputs( "\n", fp );
	}
	fclose( fp );
}
