// cubeview.h : interface of the CQuickView class
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1998 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

class CQuickView : public CView
{
protected: // create from serialization only
	CQuickView();
	DECLARE_DYNCREATE(CQuickView)

// Attributes
public:
	CQuickDoc* GetDocument();

	CPalette    m_cPalette;
	CPalette    *m_pOldPalette;
	CRect       m_oldRect;
	float       m_fRadius;
	CClientDC   *m_pDC;
	HGLRC       hrc;

// Operations
public:
	void Init();
	void CreateRGBPalette(void);
	BOOL bSetupPixelFormat(void);
	unsigned char ComponentFromIndex(int i, UINT nbits, UINT shift);
	void DrawAxis();
	void DrawPlane();
	void DrawModel();
	void DrawScene(void);

	void ComputeMouseVector();

	BOOLEAN RotationModeP, TranslationModeP, NoneModeP;
	BOOLEAN AxisModeP, PlaneModeP;
	int TotalGAxisLengthDiv, GAxisFieldDiv;
	double GAxisFieldLength, GAxisFieldSubLength;
// special
	void DrawSkeleton();
	void DrawValues();
	BOOLEAN DrawValuesP;
	int MotionNo;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CQuickView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CQuickView();
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	BOOL    m_play;

// Generated message map functions
protected:
	//{{AFX_MSG(CQuickView)
	afx_msg void OnQuickPlay();
	afx_msg void OnUpdateQuickPlay(CCmdUI* pCmdUI);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnFileOpen();
	afx_msg void OnFileSaveAs();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnButton32772();
	afx_msg void OnUpdateButton32772(CCmdUI* pCmdUI);
	afx_msg void OnButton32773();
	afx_msg void OnUpdateButton32773(CCmdUI* pCmdUI);
	afx_msg void OnButton32774();
	afx_msg void OnUpdateButton32774(CCmdUI* pCmdUI);
	afx_msg void OnButton32775();
	afx_msg void OnUpdateButton32775(CCmdUI* pCmdUI);
	afx_msg void OnButton32776();
	afx_msg void OnUpdateButton32776(CCmdUI* pCmdUI);
	afx_msg void OnButton32777();
	afx_msg void OnViewValues();
	afx_msg void OnUpdateViewValues(CCmdUI* pCmdUI);
	afx_msg void OnButton32782();
	afx_msg void OnButton32783();
	afx_msg void OnButton32784();
	afx_msg void OnUpdateButton32784(CCmdUI* pCmdUI);
	afx_msg void OnButton32788();
	afx_msg void OnUpdateButton32788(CCmdUI* pCmdUI);
	afx_msg void OnSktColor();
	afx_msg void OnMeshcolor();
	afx_msg void OnSsInterval();
	afx_msg void OnButton32793();
	afx_msg void OnUpdateButton32793(CCmdUI* pCmdUI);
	afx_msg void OnValuecolor();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnEdit3dstereo();
	afx_msg void OnUpdateEdit3dstereo(CCmdUI *pCmdUI);
};

extern CQuickView *MainView;

#ifndef _DEBUG  // debug version in cubeview.cpp
inline CQuickDoc* CQuickView::GetDocument()
   { return (CQuickDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
