// skeleton.h

#ifndef _CONSOLE
#include "stdafx.h"
#endif

#include <stdio.h>
#include <malloc.h>

#include "skeleton.h"

int frame_no = 0;
int NFrames = 0;
Vector angles[MaxFrames][BVHJoints];
Vector positions[MaxFrames];
Vector offset[BVHJoints];
Vector current_position[BVHJoints];

joint skeleton[BVHJoints];

void parent_child(int p, int a)
{
	skeleton[p].child[ skeleton[p].nchild++ ] = a;
	skeleton[a].parent = p;
}

void construct_skeleton()
{
	int i;

	for( i = 0; i < BVHJoints; i++ ){
		skeleton[i].nchild = 0;
		InitializeMatrix( skeleton[i].LMat );
		InitializeMatrix( skeleton[i].BMat );
	}

	skeleton[0].parent = -1;
/*
	parent_child( 0, 1 );
	parent_child( 0, 4 );
	parent_child( 0, 7 );
	parent_child( 1, 2 );
	parent_child( 2, 3 );
	parent_child( 4, 5 );
	parent_child( 5, 6 );
	parent_child( 7, 8 );
	parent_child( 7, 12 );
	parent_child( 7, 16 );
	parent_child( 8, 9 );
	parent_child( 9, 10 );
	parent_child( 10, 11 );
	parent_child( 12, 13 );
	parent_child( 13, 14 );
	parent_child( 14, 15 );
	parent_child( 16, 17 );
*/
}

void update_skeleton(int i)
{
	int j;

	for(j = 0; j < BVHJoints; j++){
		InitializeMatrix( skeleton[j].LMat );
		RotateZXYMatrix( skeleton[j].LMat, &angles[i][j] );
		if ( j == 0 ){
			TranslateMatrix( skeleton[j].LMat, &positions[i] );
			CopyMatrix( skeleton[j].BMat, skeleton[j].LMat );
		} else {
			TranslateMatrix( skeleton[j].LMat, &offset[j] );
			MatrixMatrixMatrix( skeleton[j].BMat, skeleton[j].LMat, skeleton[ skeleton[j].parent ].BMat );
		}
/*
		pos = *PositionMatrix( skeleton[j].BMat );
		WriteMatrix( str, skeleton[j].BMat );
		printf("Joint[%d]: %lf, %lf, %lf\n", j, pos.x, pos.y, pos.z );
		printf( str );
*/
	}
}

// for chado
void update_skeleton_of_motion1(int i)
{
	int j;

	for(j = 0; j < BVHJoints; j++){
		InitializeMatrix( skeleton[j].LMat );
		RotateZXYMatrix( skeleton[j].LMat, &angles[i][j] );
		if ( j == 0 ){
			TranslateMatrix( skeleton[j].LMat, &positions[i] );
			CopyMatrix( skeleton[j].BMat, skeleton[j].LMat );
		} else {
			TranslateMatrix( skeleton[j].LMat, &offset[j] );
			MatrixMatrixMatrix( skeleton[j].BMat, skeleton[j].LMat, skeleton[ skeleton[j].parent ].BMat );
		}
	}
}

